#!/usr/local/bin/perl -wT

select(STDERR); $| = 1; select(STDOUT); $| = 1;
use CGI;

# --- User-Konfiguration: --------------------------------

$htmlroot = "/home/html";		# der document tree des httpd
$defaultfile = "index.html";
$pseudokeepalive = "TRUE";	# siehe Text
$script = "/cgi-bin/nph-slowdown.pl";

# --- ab hier keine Konfiguration ------------------------

$query = new CGI;
$query->import_names('Q');

if( $Q::loc eq "" ) {
	&header("text/plain", "loc, bps und " .
					"del mssen in der URL angegeben werden", 0);
	exit;
}

&getfile;

# Anfangsverzgerung
if( $filelocation =~ m#\.(htm|html)$# || 
		$pseudokeepalive eq "FALSE" ) {
	sleep($Q::del);
}

# Bei HTML-Files Links ndern
$params = "&bps=$Q::bps"."&del=$Q::del";
$loc		= "?loc=$htmlroot";
if( $filelocation =~ m#\.(html|htm)$#i ) {
	$file =~ s-<a \s (.*?) href="(.*?)" (.*?)>  # "Stellen" entfernen
						-"<a $1 href=\"".&nohashes($2)."\"$3>"-xigse;
	$file =~ s-<a \s (.*?) href="/(.*?)" (.*?)>
						-<a $1 href="$script$loc/$2$params" $3>-xigs;
	$file =~ s-<a \s (.*?) href="([^/#].+?)" (.*?)>
						-<a $1 href="$script$loc$filepath$2$params" $3>-xigs;
	$file =~ s-<img \s (.*?) src="/(.*?)" (.*?)>
						-<img $1 src="$script$loc/$2$params" $3>
				 		-xigs;
	$file =~ s-<img \s (.*?) src="([^/].+?)" (.*?)>
				 		-<img $1 src="$script$loc$filepath$2$params" $3>
				 		-xigs;
	$file =~ s-<body \s (.*?) background="/(.*?)" (.*?)>
						-<body $1 background="$script$loc/$2$params" $3>
				 		-xigs;
	$file =~ s-<body \s (.*?) background="([^/].+?)" (.*?)>
				 		-<body $1 background="$script$loc$filepath$2$params" $3>
				 		-xigs;
}

$filelength = length($file);
if( $filelocation =~ m#\.(jpeg|jpg)$#i ) {
	&header("image/jpeg", "", $filelength);
} elsif( $filelocation =~ m#\.gif$#i ) {
	&header("image/gif", "", $filelength);
} elsif( $filelocation =~ m#\.(html|htm)$#i ) {
	&header("text/html", "", $filelength);
} else {
	&header("text/plain", "Dateien mit " .
			  	"dieser Endung werden nicht " .
			  	"untersttzt (Datei: '$filename')", 0);
	exit;
}

$bitps = $Q::bps;
$bytespersec = $bitps / 8;
$piecelength = $bytespersec;
$start = 0;

# hier wird abgebremst
while( $start <= $filelength ) {
	$piece = substr($file, $start, $piecelength);
	last if ( ($start + $piecelength) > $filelength );
	print "$piece";
	sleep(1);
	$start += $piecelength;
}

# auch ein evtl. verbliebenes Stck noch abschicken
$piecelength = $filelength - $start;
$piece = substr($file, $start, $piecelength);
print "$piece";
exit;

sub header {
	$contenttype = $_[0];
	$text = $_[1];
	$contentlength = $_[2];
	$contentlength = 
		length($text) if( $contentlength == 0 );
	print "HTTP/1.0 200 OK\n";
	print "Content-length: $contentlength\n";
	print "Content-type: $contenttype\n\n";
	print "$text";
}

sub getfile {
	$filelocation = $Q::loc;
	$filelocation =~ s#^(.*)/$#$1/$defaultfile#;  # URL auf Verz.
	($filename) = ($filelocation =~ m#/([^/]*?)$#);
	($filepath) = 
		($filelocation =~ m#^$htmlroot(.*?)$filename$#);
	if( ! open(INPUT, "<$filelocation") ) {
		&header("text/plain", "Kann Datei ".
						"'$filelocation' nicht ffnen: $!", 0);
		exit;
	}
	undef $/;
	$file = (<INPUT>);  # alles in einem Rutsch einlesen
	$/ = "\n";
	close(INPUT);
}

sub nohashes {
	# Positionsangaben rausfiltern
	my $anchor = $_[0];
	$anchor =~ s-([^"])#.*-$1-;  
	return "$anchor";
}
